#include <iostream>
using namespace std;
int N;
int a[1048576];
int index[1048576];
int tree[2097252];
int rTree[2097252];
int red[1048576];
int rRed[1048576];
int tSize=1;
void insert(int pos,int num)
{
     pos+=tSize;
     while(pos>0)
     {
                 tree[pos]=max(tree[pos],num);
                 pos>>=1;
     }
}
void rInsert(int pos,int num)
{
     pos+=tSize;
     while(pos>0)
     {
                 rTree[pos]=max(rTree[pos],num);
                 pos>>=1;
     }
}
int query(int pos)
{
    int tMax=-1;
    pos+=tSize;
    while(pos>1)
    {
                if((pos%2==1))
                           tMax=max(tMax,tree[pos-1]);
                pos>>=1;            
    }
    return tMax;
}

int rQuery(int pos)
{
    int tMax=-1;
    pos+=tSize;
    while(pos>1)
    {
                if((pos%2==1))
                           tMax=max(tMax,rTree[pos-1]);
                pos>>=1;            
    }
    return tMax;
}

void rBuildRed()
{
     rRed[0]=1;
     for(int i=1;i<=N;i++)
     {
             int t=rQuery(i); 
               
             rRed[i]=rRed[N-index[t]-1];
             if(a[N-i-1]>t) rRed[i]++;
     }
}

void buildRed()
{

     red[0]=1;
     for(int i=1;i<=N;i++)
     {
             int t=query(i);   
//             cout<<t<<endl;    
             red[i]=red[index[t]];
             if(a[i]>t) red[i]++;
     }     
}
int main()
{
    scanf("%d",&N);
    while(tSize<=N) tSize<<=1;
    for(int i=0;i<N;i++)
    {
            scanf("%d",&a[i]);
            index[a[i]]=i;
            insert(i,a[i]);
            rInsert(N-i-1 ,a[i]);
    }
    //for(int i=1;i<=2*tSize;i++)     cout<<rTree[i]<<" ";
    //cout<<endl;
 int b;
 /* while(1)
  {
          scanf("%d",&b);
          printf("%d\n",query(b));
          printf("%d\n",rQuery(b));
  }
  return 0;  */        
 
    buildRed();
    rBuildRed();
 //   for(int i=0;i<N;i++) cout<<red[i]<<" ";
 //   cout<<endl;
 //   for(int i=0;i<N;i++) cout<<rRed[i]<<" ";
    int ans=1002000;
    for(int i=0;i<=N;i++)
            if(ans>(i+1-red[i])+(N-i-rRed[i+1])) ans=(i+1-red[i])+(N-i-rRed[i+1]);
    
    printf("%d\n",ans);
    //cin>>N;
}
