#include <iostream>
#include <sstream>

unsigned long long toll(std::string s)
{
	std::stringstream ss(s); long long res; ss >> res; return res;
}

std::string tostr(unsigned long long l)
{
	std::stringstream ss; ss << l; std::string res; ss >> res; return res;
}

int dp[5000000], NOT_SET;
int dist(int i)
{
	int &ret = dp[i];
	if(ret != -1)	return ret;
	if(i == 1)		return ret = 0;
	if(i % 3 == 0)	return ret = dist(i / 3) + 1;
	if((i & 1) == 0)return ret = dist(i >> 1) + 1;
	return ret = dist(i + 1) + 1;
	
}



int mod3(std::string a)
{
	int res = 0;
	for(int i = 0 ; i < a.size(); i ++)
		res += a[i] - '0';
	return res % 3;
}

std::string add1(std::string a)
{
	std::string res = "0" + a;
	int i = a.size();
	while( res[i] == '9' )	res[i--] = '0';
	res[i] ++;
	if(res[0] == '0')	return res.substr(1);
	return res;
}

std::string sub1(std::string a)
{
	std::string res = a;
	int i = a.size() - 1;
	while( res[i] == '0' )	res[i--] = '9';
	res[i] --;
	if(res[0] == '0')	return res.substr(1);
	return res;
}

std::string div2(std::string a)
{
	std::string res(a.size(),'0');
	int carry = 0;
	for(int i = 0; i < a.size(); i ++)
	{
		res[i] = ( a[i] - '0' + carry * 10) / 2 + '0';
		carry = ( a[i] - '0' + carry * 10) % 2;
	}
	if(res[0] == '0')	return res.substr(1);
	return res;
}

std::string mply(std::string a,int b)
{
	std::string res(a.size() + 1, '0');
	for(int i = a.size() - 1; i >= 0; i --)
	{
		int t = res[i + 1] - '0' + (a[i] - '0') * b;
		int carry = t / 10;
		t %= 10;
		res[ i + 1 ] = t + '0';
		res[ i ] = carry + '0';
	}
	if(res[0] == '0')	return res.substr(1);
	return res;
}


unsigned long long value(unsigned long long a, unsigned long long b)
{
	if(a == b)	return a;
	if( b - a < 20 && b < 50000)
	{
		unsigned long long res = a; dist(a);
		for(unsigned long long i = a + 1; i <= b; i ++)
			if( dist(i) > dist(res) )
				res = i;
		return res;
	}
	unsigned long long res = value( a/2 + a%2, b / 2 );
//	std::cout << a << " " << b << " " << res << "\n";
	if( res % 3LL == 1 && 2 * res - 1 >= a)	return 2 * res - 1;
	return 2 * res;
}


std::string value(std::string a,std::string b)
{
	if(a == b)	return a;
	if( b.size() < 19 )
	{
		long long res = value(toll(a), toll(b));
		return tostr(res);
	}
	std::string low = div2(a);
	if(  ( a[a.size() - 1] - '0' ) & 1 )	low = add1(low);
	std::string res = value( low, div2(b) );
	if( mod3(res) == 1 && sub1( mply(res,2) ) >= a )
		return sub1( mply( res,2 ) );
	return mply(res,2);
}

std::string A,B;
unsigned long long a,b;
int main()
{
	memset(dp,-1,sizeof(dp)); NOT_SET = *dp;
//	std::cin >> A;
//	std::cout << div2(A)<<"\n";
	std::cin >> A >> B;
	if( B.size() < 19 )
	{
		a = toll( A ); b = toll( B );
		std::cout << value(a,b) << "\n";
		return 0;
	}
	std::cout << value(A,B)<<"\n";
	return 0;
}
