#include <cstdio>
#include <cstdlib>
#include <cstring>

using namespace std;

struct top
{
	int x,y,num;
};

top sx[1000001];
top sy[1000001];

int used[1000001];

int ch[1000001][4];

int n;
int br;

int cmpx(const void *a,const void *b)
{
	top *r1=(top*)a;
	top *r2=(top*)b;
	return r1->x-r2->x;
}

int cmpy(const void *a,const void *b)
{
	top *r1=(top*)a;
	top *r2=(top*)b;
	return r1->y-r2->y;
}

void dfs(int ind)
{
	used[ind]=1;
	for(int i=0;i<4;i++)
	{
		if(ch[ind][i]!=-1&&used[ch[ind][i]]==0)
		{
			br++;
			dfs(ch[ind][i]);
		}
	}
}

void solve()
{
	memset(ch,-1,sizeof(ch));
	for(int i=0;i<n-1;i++)
	{
		if(sx[i].x==sx[i+1].x)
		{	
			ch[sx[i].num][0]=sx[i+1].num;
			ch[sx[i+1].num][1]=sx[i].num;
		}
	}
	for(int i=0;i<n-1;i++)
	{
		if(sy[i].y==sy[i+1].y)
		{
			ch[sy[i].num][2]=sy[i+1].num;
			ch[sy[i+1].num][3]=sy[i].num;
		}
	}
	dfs(0);
	for(int i=1;i<n;i++)
	{
		if(used[i]==0)
		{
			br+=2;
			dfs(i);
		}
	}
}

int main()
{
	int a,b;
	scanf("%d",&n);
	for(int i=0;i<n;i++)
	{
		scanf("%d %d",&a,&b);
		sx[i].num=i;
		sx[i].x=a;
		sx[i].y=b;
		sy[i]=sx[i];
	}
	qsort(sx,n,sizeof(top),cmpx);
	qsort(sy,n,sizeof(top),cmpy);
	solve();
	printf("%d\n",br);
	return 0;
}
