#include <iostream>
#include <fstream>
#include <vector>
#include <bitset>
#include <iomanip>
#include <set>
#include <map>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <functional>
#include <utility>
#include <numeric>
#include <sstream>
#include <string>
#include <ext/numeric>

#define LL long long
#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)
#define SZ size()
#define MP make_pair
#define PB push_back
#define x first
#define y second
#define IT iterator
#define VI vector<LL>
#define PI pair<int,int>

using namespace std;

int N,M;
#define MAXN 1000100
#define MAXM 10000100
PI p[MAXN];
int adj[MAXN][4],ix[MAXN],iy[MAXN];
int *X[MAXM],*Y[MAXM],cx[MAXM],cy[MAXM];
int grc;
bool u[MAXN];
bitset<10000100> sizedx,sizedy,sortedx,sortedy;

bool cmpx(int a,int b)
{ return p[a].x<p[b].x;  }
bool cmpy(int a,int b)
{ return p[a].y<p[b].y;  }

void printxy()
{
	cout<<"X:\n";
	Repi(10)
	 if (cx[i])
	  {
	    cout<<i<<" -> ";
	    Repj(cx[i]) cout<<X[i][j]<<" ";
	    cout<<endl;
	  }
	cout<<endl;
	cout<<"Y:\n";
	Repi(10)
	 if (cy[i])
	  {
	    cout<<i<<" -> ";
	    Repj(cy[i]) cout<<Y[i][j]<<" ";
	    cout<<endl;
	  }
	cout<<endl;
}

void init()
{
	int x,y;
	Repi(N)
	{
	 x=p[i].x,y=p[i].y;
	 if (!sizedx[x])
	  {
	   X[x]=new int[cx[x]];
	   cx[x]=1;
	   X[x][0]=i;
	   sizedx[x]=1;
	  }
	 else
	  X[x][cx[x]++]=i;
	
	 if (!sizedy[y])
	  {
	   Y[y]=new int[cy[y]];
	   cy[y]=1;
	   Y[y][0]=i; 
	   sizedy[y]=1;
	  }
	 else
	  Y[y][cy[y]++]=i;
	}

   Repi(N)
    {
	 x=p[i].x,y=p[i].y;
     if (!sortedx[x])
      {
       sort(X[x],X[x]+cx[x],cmpy);
       Repj(cx[x])
        ix[X[x][j]]=j;
       sortedx[x]=1;
	  }
     if (!sortedy[y])
      {
       sort(Y[y],Y[y]+cy[y],cmpx);
       Repj(cy[y])
        iy[Y[y][j]]=j;
       sortedy[y]=1;
	  }
	}
//   printxy();   Repi(N) cout<<ix[i]<<" "; cout<<endl;   Repi(N) cout<<iy[i]<<" "; cout<<endl;
   
   memset(adj,-1,sizeof(adj));
   int Ix,Iy;
   Repi(N)
    {
		x=p[i].x,y=p[i].y;
		Ix=ix[i],Iy=iy[i];
		if (Ix) adj[i][0]=X[x][Ix-1];
		if (Ix<cx[x]-1) adj[i][2]=X[x][Ix+1];
		if (Iy) adj[i][1]=Y[y][Iy-1];
		if (Iy<cy[y]-1) adj[i][3]=Y[y][Iy+1];
		
	//	cout<<i<<" -> "; Repj(4) cout<<setw(3)<<adj[i][j]; cout<<endl;
	}
}

void dfs(int v)
{
	u[v]=1;
	Repi(4)
	 if (adj[v][i]>-1 && !u[adj[v][i]])
	  dfs(adj[v][i]);
}

int main()
{
	scanf("%d",&N);
	Repi(N)
	 {
			scanf("%d%d",&p[i].x,&p[i].y);
			cx[p[i].x]++; cy[p[i].y]++;
	 }
	
    init();
    
    grc=0;
    Repi(N)
     if (!u[i])
	  {
			grc++;
			dfs(i);
	  }
	  
	cout<<N-1+grc-1<<"\n";
//out<<(double)clock()/CLOCKS_PER_SEC<<endl;
	return 0;
}
