#include <iostream>
#include <cstdio>
#define lowbit(x) (x&(-x))
using namespace std;

const int MAXN = 1 << 20;

int i, j, k, n, N, ret;
int t[MAXN];
int a[MAXN];
int m[MAXN]; // forward
int rm[MAXN]; // backward

void push (int pos) {
    for (k = pos; k <= n; k += lowbit (k)) t[k] += 1;
}

int q (int pos) {
    ret = 0;
    for (k = pos; k > 0; k -= lowbit (k)) ret += t[k];
    return ret;
}

void solve () {
    n = 1;
    while (N > n) n *= 2;
    //printf ("%d\n", n);
    int p;
    for (i = 1; i <= N; i++) {
        p = q (a[i]);
        //printf ("query for %d = %d\n", a[i], p);
        if (p < i - 1) m[i] = m[i-1] + 1;
        else m[i] = m[i-1];
        push (a[i]);
    }
    //for (i = 1; i <= n; i++) printf ("%d ", m[i]);
    //printf ("\n");
    
    memset (t, 0, sizeof (t));
    for (i = N, j = 1; i >= 1; i--, j++) {
        p = q (a[i]);
        //printf ("query for %d = %d\n", a[i], p);
        if (p < j - 1) rm[j] = rm[j-1] + 1;
        else rm[j] = rm[j-1];
        push (a[i]);
    }
    //for (i = 1; i <= n; i++) printf ("%d ", rm[i]);
    //printf ("\n");
    int best = 9999999;
    for (i = 0; i <= N; i++) best = min (m[i] + rm[N-i], best);
    printf ("%d\n", best);
}

int main () {
    //freopen ("master.inp", "rt", stdin);
    //freopen ("master.out", "wt", stdout);
    scanf ("%d", &N);
    for (i = 1; i <= N; i++) scanf ("%d", &a[i]);
    solve ();
    return 0;
}
