#include <iostream>
#include <vector>
#include <algorithm>
#define pb push_back
#define S size ()
using namespace std;

const int MAXN = 1 << 20;

struct P {
    int x, y, v;
    P () {}
    P (int _x, int _y): x (_x), y (_y) {}
} b[MAXN];

int i, j, n, m, comp, cur, ans;
bool u[MAXN];
vector <int> a[MAXN];
int q[MAXN], br;

bool cmp1 (P q1, P q2) {if (q1.x < q2.x) return 1; else if (q1.x == q2.x && q1.y < q2.y) return 1; return 0;}

bool cmp2 (P q1, P q2) {if (q1.y < q2.y) return 1; else if (q1.y == q2.y && q1.x < q2.x) return 1; return 0;}

void bfs (int v) { //printf ("--\n");
    comp++;
    br = 0;
    q[++br] = v;
    u[v] = 1;
    int temp = 1;
    while (temp <= br) {
        for (i = 0; i < a[q[temp]].S; i++) {
            v = a[q[temp]][i];
            if (!u[v]) {
                q[++br] = v;
                u[v] = 1;
                cur++;
            }
        }
        temp++;
    }
//    for (i = 1; i <= br; i++) printf ("%d ", q[i]);
//    printf ("\n");
}

void solve () {
    // make graph
    sort (b + 1, b + n + 1, cmp1);
    for (i = 1; i < n; i++) {
        if (b[i].x == b[i+1].x) {
            a[b[i].v].pb (b[i+1].v);
            a[b[i+1].v].pb (b[i].v);
        }
    }
    sort (b + 1, b + n + 1, cmp2);
    for (i = 1; i < n; i++) {
        if (b[i].y == b[i+1].y) {
            a[b[i].v].pb (b[i+1].v);
            a[b[i+1].v].pb (b[i].v);
        }
    }
    //--
//    for (i = 1; i <= n; i++){
//    for (j = 0; j < a[i].S; j++) printf ("%d ", a[i][j]);printf("\n");}
    
    for (j = 1; j <= n; j++)
        if (!u[j]) {
            cur = 0;
            bfs (j);
            ans += cur;
        }
    ans += 2 * (comp - 1);
    printf ("%d\n", ans);
}

int main () {
    //freopen ("rook.inp", "rt", stdin);
    //freopen ("rook.out", "wt", stdout);
    scanf ("%d", &n);
    for (i = 1; i <= n; i++) scanf ("%d %d", &b[i].x, &b[i].y), b[i].v = i;
    solve ();
    return 0;
}
