// Iordan Boev SMG
# include <stdio.h>
# include <stdlib.h>
# define MAXN (1<<20)

int n,ans,cnt;
struct points {
	int x,y;
} pnt[MAXN];
int used[MAXN];

struct graf {
	int l,g,r,d,izh;
} data[MAXN];

int cmp(const void *e2,const void *e1) {
	if( ((points*)e2)->x != ((points*)e1)->x )
		return ((points*)e2)->x - ((points*)e1)->x;   	
	return ((points*)e2)->y - ((points*)e1)->y;
}


void read() {
	scanf("%d", &n);
	for(int i = 0; i < n; i++) {
		scanf("%d %d", &pnt[i].x,&pnt[i].y);
		data[i].l = -1;
		data[i].r = -1;
		data[i].g = -1;
		data[i].d = -1;
		data[i].izh = 0;	
	}	
	qsort(pnt,n,sizeof(points),cmp);
	for(int i = 1; i < n; i++) {
		int q = -1;
		if(pnt[i-1].x == pnt[i].x) {
			q = i-1;
		}
		int p=-1;
		for(int j= i-1; j >=0; j--){
			if(pnt[j].y == 	pnt[i].y) {
				p = j;
				break;	
			}
		}
		//printf("i = %d  q =  %d  p =  %d\n", i,q,p);
		data[i].l = q;
			
		if(q!= -1) {
			data[i].izh++;
			data[q].izh++;;
			data[q].r = i;
		}
		data[i].g = p;
		if(p!= -1) {
			data[i].izh++;
			data[p].izh++;
			data[p].d = i;
		}
	}
}

void dfs(int v) {
	used[v] = 1;
	ans++;
	if(used[data[v].l]== 0 && data[data[v].l].izh >= 2) {
		//if(data[v].l != -1) data[data[v].l].izh--;
		if(data[v].g != -1) data[data[v].g].izh--;
		if(data[v].r != -1) data[data[v].r].izh--;
		if(data[v].d != -1) data[data[v].d].izh--;
		dfs(data[v].l);
		return;	
	}
	if(used[data[v].g]== 0 && data[data[v].g].izh >= 2) {
		if(data[v].l != -1) data[data[v].l].izh--;
		if(data[v].r != -1) data[data[v].r].izh--;
		if(data[v].d != -1) data[data[v].d].izh--;
		dfs(data[v].g);
		return;	
	}
	if(used[data[v].r]== 0 && data[data[v].r].izh >= 2) {
		if(data[v].l != -1) data[data[v].l].izh--;
		if(data[v].g != -1) data[data[v].g].izh--;
	//if(data[v].r != -1) data[data[v].r].izh--;
		if(data[v].d != -1) data[data[v].d].izh--;
		dfs(data[v].r);
		return;	
	}	 
	if(used[data[v].d]== 0 && data[data[v].d].izh >= 2) {
		if(data[v].l != -1) data[data[v].l].izh--;
		if(data[v].g != -1) data[data[v].g].izh--;
		if(data[v].r != -1) data[data[v].r].izh--;
		dfs(data[v].d);
		return;	
	}
	if(used[data[v].l]== 0 && data[data[v].l].izh == 1) {
		data[data[v].l].izh = 0;
		cnt++;
		used[data[v].l] = 1;
		return;
	}
	if(used[data[v].g]== 0 && data[data[v].g].izh == 1) {
		data[data[v].g].izh = 0;
		cnt++;
		used[data[v].g] = 1;
		return;	
	}
	if(used[data[v].r]== 0 && data[data[v].r].izh == 1) {
		data[data[v].r].izh = 0;
		cnt++;
		used[data[v].r] = 1;
		return;	
	}	

	if(used[data[v].d]== 0 && data[data[v].d].izh == 1) {
		data[data[v].d].izh = 0;
		cnt++;
		used[data[v].d] = 1;
		return;
	}
	
	
}

void solve() {
	for(int i = 0; i < n; i++) {
		if(used[i] == 0 && data[i].izh == 0) {used[i] = 2; cnt++;}
		if(used[i] == 0 && data[i].izh > 0) dfs(i); //printf("\n");}
	}
	ans+=2*cnt-2;
	printf("%d\n", ans);		
}

int main() {
	read();

	solve();
		
	return 0;
}
