#include <iostream>
#include <fstream>
#include <vector>
#include <bitset>
#include <iomanip>
#include <set>
#include <map>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <functional>
#include <utility>
#include <numeric>
#include <sstream>
#include <string>
#include <ext/numeric>

#define LL long long
#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)
#define SZ size()
#define MP make_pair
#define PB push_back
#define x first
#define y second
#define IT iterator
#define VI vector<LL>

using namespace std;

int N,M;
#define MAXN 1000010
#define MAX(a,b) (((a)>(b))?(a):(b))
#define MIN(a,b) (((a)<(b))?(a):(b))

int a1[MAXN],a2[MAXN],a[MAXN];
int ans1[MAXN],ans2[MAXN];

inline int query1(int pos)
{
	int ret=0;
	for (;pos;pos&=pos-1)//-=pos&(-pos)) //optim
	 ret=MAX(ret,a1[pos]);
	return ret;
}

inline int push1(int pos,int val)
{
	a1[pos]=val;
	for(;pos<=N;pos+=pos&(-pos))
	 a1[pos]=MAX(a1[pos],val);
}

void solve(int a[],int ans[])
{
	memset(a1,0,sizeof(a1));
	int l,maxx=0;
	Repi(N)
	 {
	  l=query1(a[i])+1;
	  push1(a[i],l);
	  maxx=MAX(maxx,l);
	  ans[i]=maxx;
	 }
}

int main()
{
	scanf("%d",&N);
	Repi(N) scanf("%d",a+i);
	
	solve(a,ans1);
	reverse(a,a+N);
	solve(a,ans2);
	reverse(ans2,ans2+N);
	
	int ans=ans2[0];
//	Repi(N) cout<<ans1[i]<<" "; cout<<endl;
//	Repi(N) cout<<ans2[i]<<" "; cout<<endl;
	
	Repi(N)
	  ans=MIN(ans, N-(ans1[i]+ans2[i+1]) );

    printf("%d\n",ans);
//	cout<<(double)clock()/CLOCKS_PER_SEC<<endl;
	return 0;
}
