#include <iostream>
#include <fstream>
#include <vector>
#include <bitset>
#include <iomanip>
#include <set>
#include <map>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <algorithm>
#include <functional>
#include <utility>
#include <numeric>
#include <sstream>
#include <string>
#include <ext/numeric>

#define LL long long
#define Repi(n) for (int i=0;i<n;i++)
#define Repj(n) for (int j=0;j<n;j++)
#define Repk(n) for (int k=0;k<n;k++)
#define SZ size()
#define MP make_pair
#define PB push_back
#define x first
#define y second
#define IT iterator
#define PI pair<int,int>

using namespace std;

int N,M;
typedef vector<int> VI;
typedef pair<int,VI> heh;

LL osn=1000000000; int osnc=9;

string tostr(VI &a)
{
	string s;
	for (int i=a.SZ-1;i>=0;i--)
	 {
	        ostringstream ss;
			ss<<a[i];
			if (i!=a.SZ-1) Repj(osnc-ss.str().SZ) s+="0";
			s+=ss.str();
	 }
   return s;
}
VI fromstr(string s)
{
	VI a;
	ostringstream ss;
	istringstream is;
	reverse(s.begin(),s.end());
	
	Repi(s.SZ)
	 {
			ss<<s[i];
			if ((i+1)%9==0) ss<<" ";
	 }
	is.str(ss.str()); 
	ss.str(""); ss.clear();
	while(is>>s)
	 {
			reverse(s.begin(),s.end());
			ss<<s<<" ";
	 }
	
	int tek;
	is.clear(); is.str(ss.str());
	while (is>>tek) a.PB(tek);
	return a;
}


VI operator+(VI a,int b)
{
	if (!a.SZ) { a.PB(b); return a; }
	Repi(a.SZ)
	 {
			b=a[i]+b;
			a[i]=b%osn;
			b/=osn;
	 }
	if (b) a.PB(b);
	return a;
}

VI operator*(VI a,LL b)
{
	if (!a.SZ) { a.PB(0); return a; }
	LL o=0;
	Repi(a.SZ)
	 {
			o=(LL)a[i]*b+o;
			a[i]=o%osn;
			o/=osn;
	 }
	if (o) a.PB(o);
	return a;
}









LL close(LL N)
{
	LL M=0,t;
	Repi(63)
	 Repj(63)
	  {
			t=1;
			Repk(i) if (t*3LL<=N) t*=3LL; else { t=0; break; }
			if (!t) continue;
			Repk(j) if (t*2LL<=N) t*=2LL; else { t=0; break; }
			if (!t) continue;
			M>?=t;
	  }
   return M;
}





bool operator<(const VI &a,const VI &b)
{
	if (a.SZ!=b.SZ) return a.SZ<b.SZ;
	for (int i=a.SZ-1;i>=0;i--)
	 if (a[i]!=b[i]) return a[i]<b[i];
	return 0;
}

inline int len(LL N)
{
	int ans=0;
	while (N>1)
	 {
			if (N%3==0) N/=3;
			else if (N%2==0) N/=2;
			     else N++;
			ans++;
	 }
	return ans;
}

int main()
{
//	N=100;
//	 for (int i=1;i<=N;i++)
//	 len(i);

    string sa,sb;
   cin>>sa>>sb;
    //sa="1000",sb="10000";
    VI A=fromstr(sa),B=fromstr(sb);
    if (A.SZ<=2 && B.SZ<=2)
     {
			LL a,b;
			istringstream ss; ss.str(sa+" "+sb);
			ss>>a>>b;
			if (b-a<=1000000)
			 {
			   int tmp,maxc=0; LL ans=a;
			   for (LL x=a; x<=b; x++)
			    {
				 tmp=len(x);
			     if (tmp>maxc) { maxc=tmp; ans=x; }
				}
			   cout<<ans<<"\n";
			   
			 //  cout<<maxc<<"\n";
			   return 0;
			 }
	 }

    int cnttt=sb.SZ*10/3+1;
    VI t,t1,ans; int ansl=0;
    Repi(cnttt)
     Repj(cnttt)
      {
			t.clear(); t.PB(1);
			Repk(i) t=t*3;
			if (B<t) continue;
			Repk(j) t=t*2;
			if (B<t || t<A) continue;
			
//			cout<<i+j<<" "<<i<<"+"<<j<<" "<<tostr(t)<<endl;
//			cout<<len(t[0]+1)<<endl;
			
		    if (i+j>ansl) { ans=t; ansl=i+j; }
			if (i && j)
			 {
			   if ((i+j)*2>ansl)
			    {
				    t1=t+1;
					if (t1<=B) { ans=t1; ansl=(i+j)*2; }
				}
			 }
			else if (i)
			 {
					if ((i+j)*2-1>ansl)
					 {
							t1=t+1;
							if (t1<=B) { ans=t1; ansl=(i+j)*2-1; }
					 }
			 }
			
	  }

    cout<<tostr(ans)<<"\n";
	
//	system("pause");
	return 0;
}
