#include <cstdio>
#include <algorithm>

#define LB(x) ((x)&(-x))

const int MAXN = 1<<20;

int n;
int a[MAXN];

int it[MAXN];
int d[MAXN];

void read() {
    scanf ("%d",&n);
    int i;
    
    for (i=1;i<=n;i++)
        scanf ("%d",&a[i]);
}

int ask ( int x ) {
    int ans = 0;
    
    for (;x>0;x-=LB(x))
        if ( it[x] > ans ) 
            ans = it[x];
        
    return ans;
}

void ins ( int x , int p ) {
    for (;x<=n;x+=LB(x))
        if ( p > it[x] ) 
            it[x] = p;
}

void solve() {
    int i;
    int x;
    int ans;
    
    for (i=1;i<=n;i++) {
        d[i] = ask ( a[i] ) + 1;
        ins ( a[i] , d[i] );
    }
    
    ans = d[n];
    memset ( it , 0 , sizeof it );
    
    for (i=n;i>=1;i--) {
        x = ask ( a[i] ) + 1;
        if ( x + d[i-1] > ans ) ans = x + d[i-1];
        ins ( a[i] , x );
    }
    
    printf ("%d\n",n - ans);
}

int main() {
    read();
    solve();
    
    return 0;
}
