#include <cstdio>
#include <algorithm>
using namespace std;

const int MAXN = 1<<20;

#define pii pair<int,int>
#define mp make_pair

int n;
pii a[MAXN];

int comp[MAXN << 1];
int num[MAXN << 1];
int cnt;

int row[MAXN << 1];
int col[MAXN << 1];

void read() {
    int i;
    int x, y;
    
    scanf ("%d",&n);
    for (i=1;i<=n;i++) {
        scanf ("%d%d",&x,&y);
        
        comp[ ++ cnt ] = x;
        comp[ ++ cnt ] = y;
        
        a[i] = mp ( x , y );
    }
}

int bsearch ( int x ) {
    int l , r;
    int mid;
    
    l = 1;
    r = cnt;
    
    while ( 1 ) {
        mid = (l+r)/2;
        
        if ( comp[mid] == x ) return num[mid];
        if ( comp[mid] < x )  l = mid + 1;
        if ( comp[mid] > x )  r = mid - 1;
    }
}

void solve() {
    sort ( comp + 1 , comp + cnt + 1 );
    int i;
    int ans = 0;
    int cur = 0;
    int idxx , idxy;
    
    for (i=1;i<=cnt;i++) {
        if ( comp[i] != comp[i-1] )
            ++cur;
        num[i] = cur;        
    }
    
    for (i=1;i<=n;i++) {
        idxx = bsearch ( a[i].first );
        idxy = bsearch ( a[i].second );
        
        ++ ans;
        if ( !row[ idxx ] && !col[ idxy ] ) ++ ans;
        row[ idxx ] = 1;
        col[ idxy ] = 1;
    }
    
    printf ("%d\n",ans - 2);
}

int main() {
    read();
    solve();
    
    return 0;
}
