#include <stdio.h>
#include <map>
#include <vector>
using namespace std;

int prev[1000000];
map<int, int> heapX;
map<int, int> heapY;

int grandmasterfather(int a)
{
    int v = a;
    for (; v != prev[v]; v = prev[v]) prev[v] = prev[prev[v]];
    return v;
}

int cheap = 0;     
void connect(int a, int b)
{
     int v1 = grandmasterfather(a);
     int v2 = grandmasterfather(b);
     
     if (v1 == v2) return;
     
     cheap++;
     prev[v1] = v2;
}

int main()
{
    int N;
    scanf("%d", &N);
    for (int i = 0; i < N; i++) 
    {
        prev[i] = i;
        int a, b;
        scanf("%d %d", &a, &b);
        
        if (heapX[a] != 0) connect(i, heapX[a]-1);
        else heapX[a] = i+1;
        
        if (heapY[b] != 0) connect(i, heapY[b]-1);
        else heapY[b] = i+1;
    }
    
    printf("%d\n", cheap + (N-1-cheap)*2);
    return 0;
}

